/*
astrint.c Release 1.4.0  Astronomical Integer Function
Copyright (C) 2004-2005  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <math.h>

/* This program is based on Peter Duffett-Smith */
/* Practical Astronomy with Your Calculator */
/* Third Edition */
/* Cambridge University Press */
/* ISBN 0 521 35629 6 hardback */
/* ISBN 0 521 35699 7 paperback */
/* Chapter 4: Julian Day Numbers */

/* This function corresponds to the INT */
/* function in Chapter 4. */
/* INT(-3.914) = -3 */
/* INT(3.914)  =  3 */

double astrint(double number)
   {
   if (number < 0.0)
      return(ceil(number));
   else
      return(floor(number));
   } /* astrint */
