/* dgexp.c Version 1.4.0. Generate e^x between range */
/* Copyright (C) 2004-2005  dondalah@ripco.com (Dondalah) */

/* This program is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU General Public License */
/* as published by the Free Software Foundation; either version 2 */
/* of the License, or (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program; if not, write to: */

/*       Free Software Foundation, Inc. */
/*       59 Temple Place - Suite 330 */
/*       Boston, MA  02111-1307, USA. */

/* This program is compiled with Free Turbo C 2.0 */
/* From the command line, use: */

/*                make -fdatagen.mak     */

#include "datagen.h"

/* The low  end of the range is in dg->loflrng. */
/* The high end of the range is in dg->loflrng. */

void dgexp(dgfmt *dg)
   {
   double diff;
   double rslt;
   char floatfmt[32];
   char str[64];
   if (dg->hiflrng < dg->loflrng)
      {
      fprintf(stderr,"\ndgexp: invalid "
         "exponent range: %f to %f\n",
         dg->loflrng, dg->hiflrng);
      fprintf(stderr,"Low end larger than "
         "high end\n");
      exit(1);
      } /* invalid exponent range */
   if (dg->loflrng < -99.0)
      {
      fprintf(stderr,"\ndgexp: invalid "
         "exponent range: %f to %f\n",
         dg->loflrng, dg->hiflrng);
      fprintf(stderr,"Low end too small.\n");
      exit(1);
      } /* invalid exponent range */
   if (dg->hiflrng > 99.0)
      {
      fprintf(stderr,"\ndgexp: invalid "
         "exponent range: %f to %f\n",
         dg->loflrng, dg->hiflrng);
      fprintf(stderr,"High end too large.\n");
      exit(1);
      } /* invalid exponent range */
   diff = dg->hiflrng - dg->loflrng;
   rslt = dg->loflrng + (rndfrac(dg->sd) * diff);
   sprintf(floatfmt,"%s%d%s","%.", dg->dec, "f");
   sprintf(str,floatfmt,exp(rslt));
   putstr(dg->opthndl,str);
   } /* dgexp */
