#!/usr/bin/make -f

# nonintel.mak Version 1.4.0 Compile datagen for non-Intel
# platform
# Copyright (C) 2004-2005  dondalah@ripco.com (Dondalah)

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to:

# 	Free Software Foundation, Inc.
# 	59 Temple Place - Suite 330
# 	Boston, MA  02111-1307, USA.

OBJ=tst.o \
        tst2.o \
        g2jd.o \
        jd2g.o \
        dginit.o \
        slctinit.o \
        slctisrt.o \
        opnopt.o \
        cls.o \
        dgalfa.o \
        dgtext.o \
        dgltr.o \
        dgnum.o \
        dgint.o \
        dgreal.o \
        dgamt.o \
        dgintrng.o \
        dgairng.o \
        dgflrng.o \
        dgafrng.o \
        dgsine.o \
        dgexp.o \
        dglog.o \
        dgseq.o \
        dgjul.o \
        greg2jd.o \
        jd2greg.o \
        astrint.o \
        dgyear.o \
        dgmonth.o \
        dgday.o \
        dghour.o \
        dgmin.o \
        dgsec.o \
        dgdtrng.o \
        dgticks.o \
        dgslct.o \
        hxmem.o \
        puthx.o \
        putbyte.o \
        putstx.o \
        putstr.o \
        dgncpy.o \
        calclen.o \
        dgpad.o \
        slp.o \
        rndinit.o \
        rnd.o \
        rndpwr.o \
        rndnum.o \
        rndfrac.o \
	getmd5.o \
	md5c.o

CC=gcc

CFLAGS=-c -Wall -O6

LDFLAGS=-L. -ldg -lm

all:		$(OBJ) libdg.a \
                tst tst2 g2jd jd2g

tst:		$(OBJ) libdg.a
	$(CC) -Wall -O6 tst.o -o tst $(LDFLAGS)

tst2:		$(OBJ) libdg.a
	$(CC) -Wall -O6 tst2.o -o tst2 $(LDFLAGS)

g2jd:		$(OBJ) libdg.a
	$(CC) -Wall -O6 g2jd.o -o g2jd $(LDFLAGS)

jd2g:		$(OBJ) libdg.a
	$(CC) -Wall -O6 jd2g.o -o jd2g $(LDFLAGS)

libdg.a:		$(OBJ)
	rm -f libdg.a
	ar r libdg.a $(OBJ)

tst.o:			tst.c
	$(CC) $(CFLAGS) tst.c

tst2.o:			tst2.c
	$(CC) $(CFLAGS) tst2.c

g2jd.o:			g2jd.c
	$(CC) $(CFLAGS) g2jd.c

jd2g.o:			jd2g.c
	$(CC) $(CFLAGS) jd2g.c

dginit.o:		dginit.c
	$(CC) $(CFLAGS) dginit.c

slctinit.o:		slctinit.c
	$(CC) $(CFLAGS) slctinit.c

slctisrt.o:		slctisrt.c
	$(CC) $(CFLAGS) slctisrt.c

opnopt.o:		opnopt.c
	$(CC) $(CFLAGS) opnopt.c

cls.o:			cls.c
	$(CC) $(CFLAGS) cls.c

dgalfa.o:		dgalfa.c
	$(CC) $(CFLAGS) dgalfa.c

dgtext.o:		dgtext.c
	$(CC) $(CFLAGS) dgtext.c

dgltr.o:		dgltr.c
	$(CC) $(CFLAGS) dgltr.c

dgnum.o:		dgnum.c
	$(CC) $(CFLAGS) dgnum.c

dgint.o:		dgint.c
	$(CC) $(CFLAGS) dgint.c

dgreal.o:		dgreal.c
	$(CC) $(CFLAGS) dgreal.c

dgamt.o:		dgamt.c
	$(CC) $(CFLAGS) dgamt.c

dgintrng.o:		dgintrng.c
	$(CC) $(CFLAGS) dgintrng.c

dgairng.o:		dgairng.c
	$(CC) $(CFLAGS) dgairng.c

dgflrng.o:		dgflrng.c
	$(CC) $(CFLAGS) dgflrng.c

dgafrng.o:		dgafrng.c
	$(CC) $(CFLAGS) dgafrng.c

dgsine.o:		dgsine.c
	$(CC) $(CFLAGS) dgsine.c

dgexp.o:		dgexp.c
	$(CC) $(CFLAGS) dgexp.c

dglog.o:		dglog.c
	$(CC) $(CFLAGS) dglog.c

dgseq.o:		dgseq.c
	$(CC) $(CFLAGS) dgseq.c

dgjul.o:		dgjul.c
	$(CC) $(CFLAGS) dgjul.c

greg2jd.o:		greg2jd.c
	$(CC) $(CFLAGS) greg2jd.c

jd2greg.o:		jd2greg.c
	$(CC) $(CFLAGS) jd2greg.c

astrint.o:		astrint.c
	$(CC) $(CFLAGS) astrint.c

dgyear.o:		dgyear.c
	$(CC) $(CFLAGS) dgyear.c

dgmonth.o:		dgmonth.c
	$(CC) $(CFLAGS) dgmonth.c

dgday.o:		dgday.c
	$(CC) $(CFLAGS) dgday.c

dghour.o:		dghour.c
	$(CC) $(CFLAGS) dghour.c

dgmin.o:		dgmin.c
	$(CC) $(CFLAGS) dgmin.c

dgsec.o:		dgsec.c
	$(CC) $(CFLAGS) dgsec.c

dgdtrng.o:		dgdtrng.c
	$(CC) $(CFLAGS) dgdtrng.c

dgticks.o:		dgticks.c
	$(CC) $(CFLAGS) dgticks.c

dgslct.o:		dgslct.c
	$(CC) $(CFLAGS) dgslct.c

hxmem.o:		hxmem.c
	$(CC) $(CFLAGS) hxmem.c

puthx.o:		puthx.c
	$(CC) $(CFLAGS) puthx.c

putbyte.o:		putbyte.c
	$(CC) $(CFLAGS) putbyte.c

putstx.o:		putstx.c
	$(CC) $(CFLAGS) putstx.c

putstr.o:		putstr.c
	$(CC) $(CFLAGS) putstr.c

dgncpy.o:		dgncpy.c
	$(CC) $(CFLAGS) dgncpy.c

calclen.o:		calclen.c
	$(CC) $(CFLAGS) calclen.c

dgpad.o:		dgpad.c
	$(CC) $(CFLAGS) dgpad.c

slp.o:			slp.c
	$(CC) $(CFLAGS) slp.c

rndinit.o:		rndinit.c
	$(CC) $(CFLAGS) rndinit.c

rnd.o:			rnd2.c
	$(CC) $(CFLAGS) rnd2.c -o rnd.o

rndpwr.o:		rndpwr2.c
	$(CC) $(CFLAGS) rndpwr2.c -o rndpwr.o

rndnum.o:		rndnum2.c
	$(CC) $(CFLAGS) rndnum2.c -o rndnum.o

rndfrac.o:		rndfrac2.c
	$(CC) $(CFLAGS) rndfrac2.c -o rndfrac.o

getmd5.o:		getmd5.c
	$(CC) $(CFLAGS) getmd5.c

md5c.o:			md5c.c
	$(CC) $(CFLAGS) md5c.c

clean:
	rm -f $(OBJ)
	rm -f tst
	rm -f tst2
	rm -f g2jd
	rm -f jd2g
	rm -f libdg.a
